hdu 5366 The mook jong 【dp】
The mook jong
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 1065 Accepted Submission(s): 702
Problem Description
![](../../data/images/C613-1001-1.jpg)
ZJiaQ want to become a strong man, so he decided to play the mook jong。ZJiaQ want to put some mook jongs in his backyard. His backyard consist of n bricks that is 1*1,so it is 1*n。ZJiaQ want to put a mook jong in a brick. because of the hands of the mook jong, the distance of two mook jongs should be equal or more than 2 bricks. Now ZJiaQ want to know how many ways can ZJiaQ put mook jongs legally(at least one mook jong).
ZJiaQ want to become a strong man, so he decided to play the mook jong。ZJiaQ want to put some mook jongs in his backyard. His backyard consist of n bricks that is 1*1,so it is 1*n。ZJiaQ want to put a mook jong in a brick. because of the hands of the mook jong, the distance of two mook jongs should be equal or more than 2 bricks. Now ZJiaQ want to know how many ways can ZJiaQ put mook jongs legally(at least one mook jong).
Input
There ar multiply cases. For each case, there is a single integer n( 1 < = n < = 60)
Output
Print the ways in a single line for each case.
Sample Input
1
2
3
4
5
6
Sample Output
1
2
3
5
8
12
题意:有n块砖,在砖上放东西,使东西间的间隔小于等于两块砖,问有多少种放法,最少放一样东西。
思路:放第i块砖有三种放法:
第一种:放东西且和上一个砖间隔2块。不论第i-3块砖放不放东西,这种情况都继承i-3块砖的方法总数。
第二种:不放东西。这种情况继承i-1块砖的方法总数。
第三种:放东西且前面i-1块砖都不放东西。这种情况方法+1。
第一种:放东西且和上一个砖间隔2块。不论第i-3块砖放不放东西,这种情况都继承i-3块砖的方法总数。
第二种:不放东西。这种情况继承i-1块砖的方法总数。
第三种:放东西且前面i-1块砖都不放东西。这种情况方法+1。
#include<stdio.h> int main() { int n,i; long long dp[65];//输出60时会超int范围 dp[0] = 0; dp[1] = 1; dp[2] = 2; for(i = 3; i <= 60; i ++) dp[i] = dp[i-1] + dp[i-3]+1;//状态转移方程 while(scanf("%d",&n)!=EOF) { printf("%lld\n",dp[n]); } return 0; }